Subject: Re: [netmod] [Technical Errata Reported] RFC7950 (5784)

From: Warren Kumari <[email-masked]>
Date: Fri, 6 Sep 2019 15:51:29 -0400

On Wed, Jul 17, 2019 at 9:29 AM Per Hedeland <[email-masked]> wrote:
>
> On 2019-07-17 14:34, Juergen Schoenwaelder wrote:
> > Its the first half of the sentence in my copy of RFC 7950.
>
> It believe that there is a problem with English language both in Qin's
> understanding of the original text (which is correct also in my
> opinion) and in his explanation of his (mis)understanding...
>
> > I propose to reject this errata.
>
> I agree, in particular since the suggested change is IMHO no actual
> improvement. It seems the problem is in understanding the "subject to"
> construct, which is perhaps not obvious to *all* non-native English
> readers, but I can't think of a replacement that wouldn't result in an
> unecessarily complex text.

Hi all,

#include <stddisclaimer.h> // Not a YANG person.

I spent some time trying to decide between Hold for Document Update,
and Rejected. I've decided on Rejected, but if and when we decide to
update this, it may be worth addressing the text anyway.

W

>
> > /js
> >
> > On Wed, Jul 17, 2019 at 12:02:21PM +0000, Qin Wu wrote:
> >> Hi, Juergen and Rob:
> >> The condition to apply " Leading and trailing zeros are prohibited ",is the second half sentence, i.e.,"there MUST be at least one digit before and after the decimal point".
>
> It seems that you have it almost backwards... "The rule is A subject
> to the rule B" means that rule A should be applied, except when it
> will violate rule B.
>
> >> One digit before the decimal point and one digit after the decimal point at the same time cover 0.5000000?, I still don't get it.
>
> It's a very good example. With unconditional application of "Leading
> and trailing zeros are prohibited", we end up with .5 - but then we
> violate "there MUST be at least one digit before and after the decimal
> point", so we need to back out the removal of the leading zero, and
> end up with 0.5.
>
> >> Maybe I am wrong, but this is not a big deal.
>
> Hopefully the above helps...
>
> --Per
>
> >> -Qin
> >> -----®öŸö-----
> >> Ñöº: Juergen Schoenwaelder [mailto:[email-masked]]
> >> Ñ öô: 2019t7 17å 18:29
> >> 6öº: Qin Wu <[email-masked]>
> >> „ : Rob Wilton (rwilton) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; RFC Errata System <[email-masked]>
> >> ;˜: Re: [netmod] RE: [Technical Errata Reported] RFC7950 (5784)
> >>
> >> The text starts with the general case and says "Leading and trailing zeros are prohibited", which seems to cover 0.50000000 (which must be represented as 0.5.
> >>
> >> /js
> >>
> >> On Wed, Jul 17, 2019 at 09:42:38AM +0000, Qin Wu wrote:
> >>> I realized my proposed changes also have some flaw and may need to be tweaked.
> >>>
> >>> My question is should trailing zeros in  0.50000  be allowed? I didn t see the original text prohibit this.
> >>> Yes, the original text is correct, but it excludes some exception cases, such as  0.500000000 , if my understanding is correct.
> >>> Ñöº: Rob Wilton (rwilton) [mailto:[email-masked]]
> >>> Ñ öô: 2019t7 17å 17:20
> >>> 6öº: Qin Wu <[email-masked]>; Juergen Schoenwaelder
> >>> <[email-masked]>
> >>> „ : [email-masked]; [email-masked]; [email-masked]; RFC Errata
> >>> System <[email-masked]>
> >>> ;˜: RE: [netmod] T
> : [Technical Errata Reported] RFC7950 (5784)
> >>>
> >>> Hi Qin,
> >>>
> >>> I also find the current RFC text quite understandable and correct.
> >>>
> >>> The  and  is required to disallow  .0  and  0.  as valid canonical forms.  I.e. in the canonical form there MUST always be at least one digit (which could be 0) before the decimal point and then must be at least one digit (which could be 0) after the decimal point.  Otherwise, there must be no leading or trailing 0 s.  So, none of   .0 ,  0. ,  00.0 ,  0.00  and  00.00  are in the canonical form, and should be represented as  0.0  instead; similarly none of  .1 ,  1. ,  01.0 ,  1.00  and  01.00  are in the canonical form and should be represented as  1.0  instead.
> >>>
> >>> Thanks,
> >>> Rob
> >>>
> >>>
> >>> From: netmod <[email-masked]<mailto:[email-masked]>>
> >>> On Behalf Of Qin Wu
> >>> Sent: 17 July 2019 09:59
> >>> To: Juergen Schoenwaelder
> >>> <[email-masked]<mailto:j.schoenwaelder@jacobs-un
> >>> iversity.de>>
> >>> Cc: [email-masked]<mailto:[email-masked]>;
> >>> [email-masked]<mailto:[email-masked]>;
> >>> [email-masked]<mailto:[email-masked]>; RFC Errata System
> >>> <[email-masked]<mailto:[email-masked]>>
> >>> Subject: [netmod] T
> : [Technical Errata Reported] RFC7950 (5784)
> >>>
> >>>
> >>> Understand, the problem lies at "and" that is used in " one digit before and after the decimal point ", that is to say it only focus on the case that has two digits, one is before decimal point, the other digit is after decimal such as "5.06", but doesn't cover the case where "one digit before or after the decimal point ", that s why I think the case 0.500000 is not covered. We should prohibit trailing zeros in  0.5000000 .
> >>>
> >>> -----®öŸö-----
> >>> Ñöº: Juergen Schoenwaelder
> >>> [mailto:[email-masked]]
> >>> Ñ öô: 2019t7 17å 16:46
> >>> 6öº: Qin Wu <[email-masked]<mailto:[email-masked]>>
> >>> „ : RFC Errata System
> >>> <[email-masked]<mailto:[email-masked]>>;
> >>> [email-masked]<mailto:[email-masked]>;
> >>> [email-masked]<mailto:[email-masked]>;
> >>> [email-masked]<mailto:[email-masked]>
> >>> ;˜: Re: [netmod] [Technical Errata Reported] RFC7950 (5784)
> >>>
> >>>
> >>>
> >>> The text starts with the general case and says "Leading and trailing zeros are prohibited", which seems to cover 0.50000000. The text then handles the special rule that there needs to be at least one digit before and after the decimal point. I think all is fine.
> >>>
> >>>
> >>>
> >>> /js
> >>>
> >>>
> >>>
> >>> On Wed, Jul 17, 2019 at 08:11:41AM +0000, Qin Wu wrote:
> >>>
> >>>> What about "0.50000000"? based on original text, is it legal or illegal?
> >>>
> >>>> It seem original text exclude the case where one digit before or after the decimal point?
> >>>
> >>>>
> >>>
> >>>> -Qin
> >>>
> >>>> -----®öŸö-----
> >>>
> >>>> Ñöº: netmod [mailto:[email-masked]] ãh Juergen
> >>>> Schoenwaelder
> >>>
> >>>> Ñ öô: 2019t7 17å 15:50
> >>>
> >>>> 6öº: RFC Errata System
> >>>> <[email-masked]<mailto:[email-masked]>>
> >>>
> >>>> „ : [email-masked]<mailto:[email-masked]>;
> >>>> [email-masked]<mailto:[email-masked]>;
> >>>> [email-masked]<mailto:[email-masked]>
> >>>
> >>>> ;˜: Re: [netmod] [Technical Errata Reported] RFC7950 (5784)
> >>>
> >>>>
> >>>
> >>>> I do not see why the original text makes 0.5 or 0.0 illegal.
> >>>
> >>>>
> >>>
> >>>> /js
> >>>
> >>>>
> >>>
> >>>> On Tue, Jul 16, 2019 at 08:52:52PM -0700, RFC Errata System wrote:
> >>>
> >>>>> The following errata report has been submitted for RFC7950, "The
> >>>
> >>>>> YANG
> >>>
> >>>>> 1.1 Data Modeling Language".
> >>>
> >>>>>
> >>>
> >>>>> --------------------------------------
> >>>
> >>>>> You may review the report below and at:
> >>>
> >>>>> https://www.rfc-editor.org/errata/eid5784
> >>>
> >>>>>
> >>>
> >>>>> --------------------------------------
> >>>
> >>>>> Type: Technical
> >>>
> >>>>> Reported by: Qin WU
> >>>>> <[email-masked]<mailto:[email-masked]>>
> >>>
> >>>>>
> >>>
> >>>>> Section: 9.3.2
> >>>
> >>>>>
> >>>
> >>>>> Original Text
> >>>
> >>>>> -------------
> >>>
> >>>>> Leading and trailing zeros are prohibited, subject to the rule
> >>>>> that
> >>>
> >>>>> there MUST be at least one digit before and after the decimal point.
> >>>
> >>>>> The value zero is represented as "0.0".
> >>>
> >>>>>
> >>>
> >>>>>
> >>>
> >>>>>
> >>>
> >>>>>
> >>>
> >>>>> Corrected Text
> >>>
> >>>>> --------------
> >>>
> >>>>> Leading zeros before the first digit and trailing zeros after the
> >>>
> >>>>> last digit are prohibited, subject to the rule that there MUST be
> >>>>> at
> >>>
> >>>>> least one digit before and after the decimal point.  The value
> >>>>> zero
> >>>
> >>>>> is represented as "0.0".
> >>>
> >>>>>
> >>>
> >>>>> Notes
> >>>
> >>>>> -----
> >>>
> >>>>> Based on the rule in the orginal text, the value such as "0.5","0.0" is illegal. So I think the intention of the original text is to make sure the leading zeros before the first digit and the trailing zero after the last digit are prohibited.
> >>>
> >>>>>
> >>>
> >>>>> Instructions:
> >>>
> >>>>> -------------
> >>>
> >>>>> This erratum is currently posted as "Reported". If necessary,
> >>>>> please
> >>>
> >>>>> use "Reply All" to discuss whether it should be verified or rejected.
> >>>
> >>>>> When a decision is reached, the verifying party can log in to
> >>>>> change
> >>>
> >>>>> the status and edit the report, if necessary.
> >>>
> >>>>>
> >>>
> >>>>> --------------------------------------
> >>>
> >>>>> RFC7950 (draft-ietf-netmod-rfc6020bis-14)
> >>>
> >>>>> --------------------------------------
> >>>
> >>>>> Title               : The YANG 1.1 Data Modeling Language
> >>>
> >>>>> Publication Date    : August 2016
> >>>
> >>>>> Author(s)           : M. Bjorklund, Ed.
> >>>
> >>>>> Category            : PROPOSED STANDARD
> >>>
> >>>>> Source              : Network Modeling
> >>>
> >>>>> Area                : Operations and Management
> >>>
> >>>>> Stream              : IETF
> >>>
> >>>>> Verifying Party     : IESG
> >>>
> >>>>>
> >>>
> >>>>> _______________________________________________
> >>>
> >>>>> netmod mailing list
> >>>
> >>>>> [email-masked]<mailto:[email-masked]>
> >>>
> >>>>> https://www.ietf.org/mailman/listinfo/netmod
> >>>
> >>>>
> >>>
> >>>> --
> >>>
> >>>> Juergen Schoenwaelder           Jacobs University Bremen gGmbH
> >>>
> >>>> Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
> >>>
> >>>> Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>
> >>>
> >>>>
> >>>
> >>>> _______________________________________________
> >>>
> >>>> netmod mailing list
> >>>
> >>>> [email-masked]<mailto:[email-masked]>
> >>>
> >>>> https://www.ietf.org/mailman/listinfo/netmod
> >>>
> >>>
> >>>
> >>> --
> >>>
> >>> Juergen Schoenwaelder           Jacobs University Bremen gGmbH
> >>>
> >>> Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
> >>>
> >>> Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>
> >>
> >> --
> >> Juergen Schoenwaelder           Jacobs University Bremen gGmbH
> >> Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
> >> Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>
> >
>

--
I don't think the execution is relevant when it was obviously a bad
idea in the first place.
This is like putting rabid weasels in your pants, and later expressing
regret at having chosen those particular rabid weasels and that pair
of pants.
   ---maf